/*
 * Lock simples com futex.  um boa abordagem?
 */
#define _GNU_SOURCE
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <linux/futex.h>
#include <sys/time.h>
#include <sys/syscall.h>
#include <sys/types.h>
#include <limits.h>

#define N 10

volatile int s = 0; /* Varivel compartilhada */
volatile int lock = 0;

/* Retorna -1 se o futex no bloqueou e 
            0 caso contrrio */
int futex_wait(void *addr, int val1) {
  return syscall(SYS_futex, addr, FUTEX_WAIT, 
                 val1, NULL, NULL, 0);
}

/* Retorna o nmero de threads que foram acordadas */
int futex_wake(void *addr, int n) {
    return syscall(SYS_futex, addr, FUTEX_WAKE, 
                   n, NULL, NULL, 0);
}

void* f_thread(void *v) {
  int thr_id = *(int*)v;
  int i;

  for (i = 0; i < 5; i++) {
    while (!__sync_bool_compare_and_swap (&lock, 0, 1))
	futex_wait(&lock,0); 

  s = thr_id;
  printf("Thread %d, s = %d.\n", thr_id, s); 
  
  lock = 0;  /* Libera o lock */
  sleep(1);
  }
  return NULL;

}

int main() {

  pthread_t thr[N];
  int id[N], i;

  for (i = 0; i < N; i++) {
    id[i] = i;
    pthread_create(&thr[i], NULL, f_thread, &id[i]);
  }

  for (i = 0; i < N; i++) 
    pthread_join(thr[i], NULL); 

  return 0;
}

